/*-
 * Copyright (c) 1996 Berkeley Software Design, Inc.
 * All rights reserved.
 * The Berkeley Software Design Inc. software License Agreement specifies
 * the terms and conditions for redistribution.
 *
 *	BSDI authenticate.c,v 2.4 1996/11/13 23:54:43 prb Exp
 */

#include <sys/param.h>
#include <sys/wait.h>

#include <login_cap.h>
#include <pwd.h>
#include <stdio.h>
#include <strings.h>
#include <unistd.h>

char *
pap_authenticate(char *user, char *passwd)
{
	char *style = 0;
	struct passwd *pwd;
	login_cap_t *lc;

	if ((pwd = getpwnam(user)) == NULL)
		return("no such user");

	if ((lc = login_getclass(pwd->pw_class)) == NULL)
		return("user has no login class");
	
	style = login_getstyle(lc, 0, "pap");

    	if (!style) {
		login_close(lc);
		return("authentication style not available");
	}

	if (auth_response(user, lc->lc_class, style, "response", NULL, "",
	    passwd) > 0)
		return(0);
	return("authentication denied");
}
