/*-
 * Copyright (c) 1996 Berkeley Software Design, Inc.
 * All rights reserved.
 * The Berkeley Software Design Inc. software License Agreement specifies
 * the terms and conditions for redistribution.
 *
 *	BSDI getindexbyifname.c,v 2.3 1996/11/13 23:54:43 prb Exp
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <net/if_dl.h>
#include <ifaddrs.h>
#include <stdlib.h>
#include <string.h>

int
getindexbyifname(char *name)
{
	struct ifaddrs *ifaddrs, *ifa;
	int ni;

	if (getifaddrs(&ifaddrs) < 0)
		return(-1);

	ni = -1;

	for (ifa = ifaddrs; ifa != NULL; ifa = ifa->ifa_next) {
		if (ifa->ifa_addr &&
		    ifa->ifa_addr->sa_family == AF_LINK &&
		    strcmp(ifa->ifa_name, name) == 0) {
			ni = ((struct sockaddr_dl*)ifa->ifa_addr)->sdl_index;
			break;
		}
	}

	free(ifaddrs);
	return(ni);
}
